ircd-hybrid-6.2-revjupe.patch

Reverse Jupe patch:
	The idea of this patch is to reverse the meaning of a channel jupe - so
	that the only channels that can be joined are those that are juped, by
	a Q: line in the ircd.conf.

	Such channels persist without any users in them, and are initially
	created with mode +nt and a topic given by Q: line's comment field.
	
	Note: Being the first to join such a channel does not confer chanop
	status - since the channel already existed.  You must use irc services
	like OperServ or ChanServ to get chanops.

		- caf. (Kevin Easton) <s3159795@student.anu.edu.au>
		Feb 10 2002.

Applying:
	Change to the ircd-hybrid-6.2 directory and run:

	patch -p0 < /path/to/ircd-hybrid-6.2-revjupe.patch
	
	It should apply cleanly.  You will need to #define the JUPE_CHANNEL
	option in config.h to make use of the patch.
	

--- src/channel.c.old	Sun Feb 10 01:15:33 2002
+++ src/channel.c	Sun Feb 10 01:16:55 2002
@@ -615,7 +615,7 @@
   Link  *lp;
 
 #ifdef JUPE_CHANNEL
-  if (MyClient(cptr) && chptr->juped)
+  if (MyClient(cptr) && !chptr->juped)
     {
       return 1;
     }
@@ -1897,7 +1897,7 @@
   int ban_or_exception;
 
 #ifdef JUPE_CHANNEL
-  if(chptr->juped)
+  if(!chptr->juped)
     {
       sendto_ops_flags(FLAGS_SPY,
              "User %s (%s@%s) is attempting to join locally juped channel %s",
--- src/s_conf.c.old	Mon Aug  6 04:40:52 2001
+++ src/s_conf.c	Sun Feb 10 01:54:40 2002
@@ -2477,6 +2477,7 @@
                   strcpy(chptr->chname, aconf->name);
 /*                chptr->juped;   what the hell was that there for?*/
                   chptr->juped = 1;  /* maybe this ? */
+		  chptr->mode.mode = MODE_TOPICLIMIT | MODE_NOPRIVMSGS;
                   if (channel)
                     channel->prevch = chptr;
                   chptr->prevch = NULL;
@@ -2488,8 +2489,14 @@
                   Count.chan++;
                 }
 
-              if(aconf->passwd)
+              if(aconf->passwd) {
                 strncpy_irc(chptr->topic, aconf->passwd, TOPICLEN);
+#ifdef TOPIC_INFO
+		strncpy_irc(chptr->topic_nick, me.name, NICKLEN);
+		chptr->topic_time = CurrentTime;
+#endif
+              }
+		
             }
 #endif
 
